#include <stdio.h>
#include <dos.h>
#include <stdlib.h>

union REGS r;
FILE *pf;
char *pal;
int i;

void do_plasma (int x1,int y1,int x2,int y2,int rec_lev);
void putpixel(int x,int y,char col);
unsigned char getpixel(int x,int y);
unsigned char media(int x1,int y1,int x2,int y2,int rec_lev);

main()
{
 r.x.ax=0X0013;
 int86(0X10,&r,&r);

 pal=malloc(768);
 pf=fopen("topo.pal","rb");
 fread(pal,768,1,pf);
 fclose(pf);
 for(i=0;i<768;i+=3)
 {
  outportb(0X3C8,i/3);
  outportb(0X3C9,(*(pal+i))>>2);
  outportb(0X3C9,(*(pal+i+1))>>2);
  outportb(0X3C9,(*(pal+i+2))>>2);
 }
 free(pal);


 randomize();
 putpixel(0,0,random(256));
 //putpixel(0,199,random(256));
 //putpixel(160,100,random(256));
 //putpixel(319,0,random(256));
 //putpixel(319,199,random(256));
 do_plasma(0,0,320,200,768);

 getch();

 r.x.ax=0X0003;
 int86(0X10,&r,&r);
 printf("Coded by Bellotti Stefano (Alias Signo).\n");
 return(0);
}




void do_plasma (int x1,int y1,int x2,int y2,int rec_lev)
{
 int x,y,col;

 x=(x2+x1)>>1;
 y=(y2+y1)>>1;
 if(x!=x1 || y!=y1)
 {
  if(getpixel(x,y1)==0) putpixel(x,y1,media(x1,y1,x2,y1,rec_lev));
  col=getpixel(x,y1);
  if(getpixel(x,y2)==0) putpixel(x,y2,media(x1,y2,x2,y2,rec_lev));
  col+=getpixel(x,y2);
  if(getpixel(x1,y)==0) putpixel(x1,y,media(x1,y1,x1,y2,rec_lev));
  col+=getpixel(x1,y);
  if(getpixel(x2,y)==0) putpixel(x2,y,media(x2,y1,x2,y2,rec_lev));
  col+=getpixel(x2,y);

  col=(col>>2)+random((int)rec_lev*2+2)-rec_lev;
  if(col<1) col=1;
  if(col>255) col=255;
  putpixel(x,y,col);

  do_plasma(x1,y1,x,y,rec_lev>>1);
  do_plasma(x,y1,x2,y,rec_lev>>1);
  do_plasma(x1,y,x,y2,rec_lev>>1);
  do_plasma(x,y,x2,y2,rec_lev>>1);
 }
}



void putpixel(int x,int y,char col)
{
 unsigned int ind;

 ind=(y%200)*320+x%320;
 asm {
  push  es
  mov   ax,0A000h
  mov   es,ax
  mov   di,ind
  mov   al,col
  mov   es:[di],al
  pop   es
 }
}




unsigned char getpixel(int x,int y)
{
 unsigned int ind;
 char col;

 ind=(y%200)*320+x%320;
 asm {
  push  es
  mov   ax,0A000h
  mov   es,ax
  mov   di,ind
  mov   al,es:[di]
  mov	col,al
  pop   es
 }
 return(col);
}



unsigned char media(int x1,int y1,int x2,int y2,int rec_lev)
{
 int col;
 col=(((int)getpixel(x1,y1)+getpixel(x2,y2))>>1)+random((int)rec_lev*2+2)-rec_lev;
 if(col<1) col=1;
 if(col>255) col=255;
 return col;
}
